module std.c.time;

extern (C):

version (Linux)
{
    alias int time_t;
    
    struct timeval
    {
        int tv_sec; /* Seconds */
        int tv_usec; /* Milliseconds */
    }
    
    struct timezone
    {
        int tz_minuteswest; /* Minutes west of Greenwich */
        int tz_dsttime; /* Obsolete */
    }
    
    int gettimeofday (timeval *tv, timezone *tz);
    int settimeofday (timeval *tv, timezone *tz);
    time_t time (time_t *timer);
}